include("scripts/bugs/JFBugs.lua")

--------------------------------------------------------------------------------------------------
--                                        Startup function
--------------------------------------------------------------------------------------------------

function JFHugBugOnOpen(posx, posy, token)
    -- getting minigame model
    local mgs = JFServiceLocator:serviceOfType(JFMiniGameCacheService:class())
    local mgModel = mgs:miniGameWithToken(token)
    local expiryDate = JFUtility:convertServerTimeToClientTime(mgModel:performSelector("expire_date"))
    local minigameInfo ={bugtype="BUG1",
                        wanderRadius=20.0,
                        maxNumberGenerations=3,
                        baseSpeed=15,
                        speedScaling=1.2,
                        sizeScaling=0.8,
                        villagerScareInterval=3,
                        villagerScareRadius=30.0,
                        invincibleDuration=1,
                        token=token,
                        minigameModel = mgModel,
                        expiryDate=expiryDate,
                        liveBugs=1,
                        bugIdentifier=1
                        }
    local bug = JFHugBug:initWithModel_fromToken_withMinigameInfo(nil, token, minigameInfo)
    bug.payout_number = 1
    bug:spawnAtPosition(CGPoint(posx, posy))
end

--------------------------------------------------------------------------------------------------
--                                        JFHugBug
--------------------------------------------------------------------------------------------------
waxClass{"JFHugBug", JFBug}

function setupHitBox(self)
    self.hitbox = CCNode:node()
    self.hitbox:setContentSize(CGSize(55,65))
    self.hitbox:setAnchorPoint(CGPoint(0.4,0))
    self.hitbox:setPosition(CGPoint(0,5))
    self:rootNode():addChild(self.hitbox)
end

function ident(self)
    return self.identifier
end

function classId(self)
    return JFUtility:convertClassToClassId(JFHugBug:class())
end
