
include("scripts/pranks/JFHugBugPrank.lua")
include("scripts/pranks/JFMosquitoPrank.lua")


--------------------------------------------------------------------------------------------------
--										Startup function
--------------------------------------------------------------------------------------------------

function JFFoolsPranksOnOpen(posx, posy)
    -- black plague notification
    --local plague = JFAprilPlagueHandler:initWithModel(nil)
    math.randomseed(os.time())
    math.random()
    local randNum = math.random(1,100)
    if randNum < 20 then
        JFHugBugOnOpen(posx, posy, nil)
    elseif randNum < 40 then
        JFMosquitoOnOpen(posx, posy, nil)
    elseif randNum < 60 then
        JFGrakBirdPrankOnOpen()
    else
        JFResizeVillagerPrank:initWithModel(nil)
    end
end

function JFGrakBirdPrankOnOpen()
    local gos = JFServiceLocator:serviceOfType(JFGameObjectService:class())
    local colours = {grak_feather_01="0x643296",
                        grak_foot="0x007D96",
                        grak_mouth="0x960000",
                        grak_main="0xFFAF00",
                        grak_tail_01="0x643296",
                        grak_tail_02="0x643296",
                        grak_feather_02="0x007D96"}
    local details = JMMiniGameDetail:new()
    details:setColours(colours)
    for i=1,10 do
        local grak = JFGrakBird:alloc():initFlyBy(details)
        grak:setScreenPos(CGPoint(-100-(math.random(1,800)), 12*(math.random(1,50)-math.random(1,50))))
        local model = JMMiniGame:new()
        model:setToken("g" .. gos:nextUniqueIdentifier())
        grak:setModel(model)
        gos:addGameObject(grak)
    end
end

--------------------------------------------------------------------------------------------------
--                                        JFResizeVillagerPrank
--------------------------------------------------------------------------------------------------
waxClass{"JFResizeVillagerPrank", JFGameObject}

local gos = JFServiceLocator:serviceOfType(JFGameObjectService:class())
local scheduler = CCDirector:sharedDirector():scheduler()

function initWithModel(self, model)
    self = self.super:initWithModel(model)
    if self then
        local objectsToRemove = gos:gameObjectsWithClassId(self:classId())
        if objectsToRemove~=nil then
            for i, obj in ipairs(objectsToRemove) do
                gos:removeGameObject(obj)
            end
        end
        gos:addGameObject(self)
        scheduler:scheduleSelector_forTarget_interval_paused_repeat_delay("setVillagersToOriginalSize", self, 0, false, 0, 90)
        self:giantVillagersPrank()
    end
    return self
end

function classId(self)
    return JFUtility:convertClassToClassId(JFResizeVillagerPrank:class())
end

function giantVillagersPrank(self)
    local villagers = gos:gameObjectsWithClassType(JFVillager:class())
    for i, v in ipairs(villagers) do
        if math.random(1,100) <= 50 then
            v:offsetNode():setScale(0.6)
        else
            v:offsetNode():setScale(1.6)
        end
    end
end

function setVillagersToOriginalSize(self)
    local villagers = gos:gameObjectsWithClassType(JFVillager:class())
    for i, v in ipairs(villagers) do
        v:offsetNode():setScale(1)
    end
    gos:removeGameObject(self)
end

function handleMessage(self, message)
    if self.super.handleMessage == self.handleMessage then
        self.super:handleMessage(message)
        return
    end
    if message:name() == "removeGameObject" then
        scheduler:unscheduleAllSelectorsForTarget(self)
    end
    self.super:handleMessage(message)
end
