include("scripts/pranks/JFBugsPrank.lua")


--------------------------------------------------------------------------------------------------
--                                        Startup function
--------------------------------------------------------------------------------------------------

function JFMosquitoOnOpen(posx, posy, token)
    -- getting minigame model
    local expiryDate = NSDate:date():dateByAddingTimeInterval(45)

    local minigameInfo = {bugtype="MOSQUITO",
                        wanderRadius=10.0,
                        maxNumberGenerations=3,
                        baseSpeed=70,
                        baseSize=2.0,
                        speedScaling=1.1,
                        sizeScaling=1.2,
                        villagerScareInterval=3,
                        villagerScareRadius=25.0,
                        invincibleDuration=1,
                        token=token,
                        expiryDate=expiryDate,
                        liveBugs=1,
                        bugIdentifier=1
                        }
    local bug = JFMosquito:initWithModel_fromToken_withMinigameInfo(nil, token, minigameInfo)
    bug.payout_number = 1
    bug:spawnAtPosition(CGPoint(posx, posy))
end

--------------------------------------------------------------------------------------------------
--                                        JFMosquito
--------------------------------------------------------------------------------------------------
waxClass{"JFMosquito", JFBug}

function setupHitBox(self)
    self.hitbox = CCNode:node()
    self.hitbox:setContentSize(CGSize(65,65))
    self.hitbox:setAnchorPoint(CGPoint(0.5,0.5))
    self.hitbox:setPosition(CGPoint(10,35))
    self:rootNode():addChild(self.hitbox)
end

function ident(self)
    return self.identifier
end

function classId(self)
    return JFUtility:convertClassToClassId(JFMosquito:class())
end