
--------------------------------------------------------------------------------------------------
--										Startup function
--------------------------------------------------------------------------------------------------

function JFTombstoneGiftOnOpen(posx, posy)
    -- black plague notification
    local plague = JFAprilPlagueHandler:initWithModel(nil)
    --hudService:queueAlert(alertMessage)
    
    
end

--------------------------------------------------------------------------------------------------
--										PlagueHandler
--------------------------------------------------------------------------------------------------

waxClass{"JFAprilPlagueHandler", JFGameObject}

local hudService = JFServiceLocator:serviceOfType(JFHUDService:class())
local goService = JFServiceLocator:serviceOfType(JFGameObjectService:class())
local scheduler = CCDirector:sharedDirector():scheduler()

function initWithModel(self, model)
    self = self.super:initWithModel(model)
    if self then
        -- need to add to game service to deschedule if user views another village
        goService:addGameObject(self)
        
        -- black plague notification
        scheduler:scheduleSelector_forTarget_interval_paused_repeat_delay("pushInitialAlert", self, 0, false, 0, 2)
        -- schedule villager deaths
        scheduler:scheduleSelector_forTarget_interval_paused_repeat_delay("killVillagers", self, 0, false, 0, 0.5)
        -- notification that it's a joke and undoing tombstonification
        scheduler:scheduleSelector_forTarget_interval_paused_repeat_delay("undoPrank", self, 0, false, 0, 12)
    end
    return self
end

function pushInitialAlert(self)
    local alertMessage = JFUIAlertMessage:alertWithTitle_message_useLarge("UH OH", "You opened a deadly plague!", false)
    hudService:queueAlert(alertMessage)
end

local villagerStateAnimate = JFVillagerStateAnimate:class()
local villagerStateResume = JFVillagerStateResumeModelState:class()

function undoPrank(self)
    self:pushFinalAlert()
    self:unkillVillagers()
    goService:removeGameObject(self)
end


local tombstones = {}

function killVillagers(self)
    local villagers = goService:gameObjectsWithClassType(JFVillager:class())
    local data = {nodata="nothing here"}
    local message = JFMessage:messageWithName("animation")
    message:setData(messageData)
    for i, villager in ipairs(villagers) do
        if villager:villagerModel():ageCategory() ~= VILLAGER_AGE_CATEGORY_BABY then
            villager:fxWardrobe():playAnimation("FX_AGE_TRANSITION"):addCallbackOnFinished_withSelector(villager, "onFinishedBoostAnimation:withAnimation:")
            villager:stateMachine():setCurrentState_withMessage(villagerStateAnimate, message)
            villager:wardrobe():setVisible(false)
            local tombstone = CCBReader:nodeGraphFromFile("Tombstone.ccbi")
            villager:rootNode():addChild(tombstone)
            tombstone:setAnchorPoint(CGPoint(0.5, 0))
            tombstone:setPosition(CGPoint(0.0, 0.0))
            tombstone:setVisible(true)
            table.insert(tombstones, tombstone)
        end
    end
end

function unkillVillagers(self)
    for i, t in ipairs(tombstones) do
        t:removeFromParentAndCleanup(true)
    end
    local villagers = goService:gameObjectsWithClassType(JFVillager:class())
    for i, villager in ipairs(villagers) do
        if villager:villagerModel():ageCategory() ~= VILLAGER_AGE_CATEGORY_BABY then
            villager:fxWardrobe():playAnimation("FX_AGE_TRANSITION"):addCallbackOnFinished_withSelector(villager, "onFinishedBoostAnimation:withAnimation:")
            villager:stateMachine():setCurrentState_withMessage(villagerStateResume, nil)
            villager:wardrobe():setVisible(true)
        end
    end
end

function pushFinalAlert(self)
    local alertMessage = JFUIAlertMessage:alertWithTitle_message_useLarge("APRIL FOOLS", "Your Meego still alive! Graven sent April Fools plague as joke.", false)
    hudService:queueAlert(alertMessage)
end

function handleMessage(self, message)
    self.super:handleMessage(message)
    if message:name() == "removeGameObject" then 
        scheduler:unscheduleAllSelectorsForTarget(self)
    end
end

function classId(self)
    return JFUtility:convertClassToClassId(JFAprilPlagueHandler:class())
end

function ident(self)
    return 1
end