-- Set up for all the patched wax classes
-- Put the names of the files that contain your wax classes in 'patchedLuaScripts'
-- and the names of the Obj-C classes to patch in 'classesToPatch'

print("Setting up...")
local scriptingService = JFScriptingService:instance()
local patcher = JFPatcher:defaultPatcher()


------------------------------------------------------
-- Include lua files here
------------------------------------------------------

-- Files that need patching should be put in to the patchedLuaScripts array
-- eg. local patchedLuaScripts = {"JFGrakBirdStatePatched.lua", "JFVillagerPatched.lua", "JFVillageServicePatched.lua"}

local patchedLuaScripts = {
        -- patch scripts here
    }

for i, luaScript in ipairs(patchedLuaScripts) do
    local scriptPath = patcher:getResourcePath(luaScript)
    if (scriptPath ~= nil) then
        print("include " .. scriptPath)
        include(scriptPath)
    end
end

------------------------------------------------------
-- Patch classes here
------------------------------------------------------

-- Any class that you want to patch should be in the patchedClasses array
-- eg. local classesToPatch = {"JFGrakBirdFlyAway", "JFVillager"}
-- The equivalent patched class should have the same name, but be appended with 'Patched'
-- eg. The objective-C class JFGrakBirdFlyAway will become the wax class JFGrakBirdFlyAwayPatched

local classesToPatch = {
        -- classes to patch here
    }

for i, classToPatch in ipairs(classesToPatch) do
    scriptingService:patchAlloc(classToPatch)
end